//          Copyright Jason Wagner 2008
// Distributed under the Boost Software License, Version 1.0.
//    (See accompanying file LICENSE_1_0.txt or copy at
//          http://www.boost.org/LICENSE_1_0.txt)

#ifndef BOOST_LOGGING_LOGGER_HPP_
#define BOOST_LOGGING_LOGGER_HPP_


namespace boost { namespace logging {

/**
 * Controls a hierarchy of channels, each with a filter_action and variable_set that
 * is used by loggers on that channel.
 *
 * This is completely un-implemented, if you didn't notice.
 */
template<class CharT = char, class TraitsT= std::char_traits< CharT > >
struct basic_core {
  typedef std::basic_string<CharT,TraitsT> string_type;

// get the logger necessities for a given channel
   variable_set&  variable_set(const string_type& channel_name);
   filter_action& filter(const string_type& channel);
// populate a whole channel
   void get(const string_type& channel_name);





};

typedef basic_core<char,std::char_traits<char> > core;


}} // namespace boost::logging
#endif BOOST_LOGGING_CORE_HPP_
