//          Copyright Jason Wagner 2008
// Distributed under the Boost Software License, Version 1.0.
//    (See accompanying file LICENSE_1_0.txt or copy at
//          http://www.boost.org/LICENSE_1_0.txt)

#ifndef BOOST_LOGGING_SINKS_OSTREAM_SINK_HPP_
#define BOOST_LOGGING_SINKS_OSTREAM_SINK_HPP_

#include <iostream>
#include <boost/logging/sinks/sink.hpp>

namespace boost { namespace logging { namespace sinks {

struct ostream_sink : public sink
{
  ostream_sink(std::ostream& o) : out(o) {}

  virtual void set_formatter(boost::shared_ptr<formatter> formatter)
  {

  }

  void write(const std::string& msg)
  {
    out << msg;
  }
private:
  std::ostream& out;
};



}}} // namespace boost::logging::sinks

#endif /*BOOST_LOGGING_SINKS_OSTREAM_SINK_HPP_*/
