//          Copyright Jason Wagner 2008
// Distributed under the Boost Software License, Version 1.0.
//    (See accompanying file LICENSE_1_0.txt or copy at
//          http://www.boost.org/LICENSE_1_0.txt)

#ifndef SINK_HPP_
#define SINK_HPP_

#include <boost/config.hpp>
#include <boost/shared_ptr.hpp>
#include <boost/logging/filters.hpp>

namespace boost { namespace logging {
struct formatter
{
  virtual std::string on_start(const variable_set& v)=0;
  virtual std::string on_change(const variable_set& v)=0;
  virtual std::string on_end(const variable_set& v)=0;

};

struct sink : public filter_action {
  typedef boost::shared_ptr<sink> ptr;

  virtual void get_sinks(const variable_set& v, sink_list& s)
  {
    //sink_list::value_type p(this);
    s.push_back(this);
  }

  virtual void set_formatter(boost::shared_ptr<formatter> formatter)=0;

  virtual void write(const std::string& str)=0;
};

}} // namespace boost::logging


#endif /*SINK_HPP_*/
