#include <iostream>
#include <time.h>
#include <boost/logging/logger.hpp>
#include <boost/logging/conditions.hpp>
#include <boost/logging/lazy.hpp>
#include <boost/logging/sinks/ostream_sink.hpp>
namespace bl=boost::logging;
const int COUNT=100000;

long sum(long n)
{
  if(n==0)
    return 0;
  return n+sum(n-1);
}
struct summer {
  long sum(long n)
  {
    if(n==0)
      return 0;
    return n+sum(n-1);
  }
};


template<class L>
void test_lazy_on(L& s)
{
  clock_t start, end;
  summer su;
  start=clock();
  for(int i=0; i<COUNT;++i)
  {
    s << bl::severity::error() << "error(i=" << i << "," << bl::lazy(&sum,50000) << ") error (text here)"
      << bl::lazy(&summer::sum,&su,50000)
      << bl::eol()
      ;
    s.end_record();
  }
  end=clock();
  std::cerr << "Lazy printed took " << double(end-start)/double(CLOCKS_PER_SEC) << "\n";
}

template<class L>
void test_lazy_off(L& s)
{
  clock_t start, end;
  summer su;
  start=clock();
  for(int i=0; i<COUNT;++i)
  {
    s << "w" << bl::severity::info() << "error(i=" << i << "," << bl::lazy(&sum,50000) << ") error (text here)"
      << bl::lazy(&summer::sum,&su,50000)
      << bl::eol()
      ;
    s.end_record();
  }
  end=clock();
  std::cerr << "Lazy not printed " << double(end-start)/double(CLOCKS_PER_SEC) << "\n";
}

template<class L>
void test_empty(L& s)
{
  clock_t start, end;
  start=clock();
  for(int i=0; i<COUNT;++i)
  {
    i+=sum(2)-sum(2);
  }
  end=clock();
  std::cerr << "Empty " << double(end-start)/double(CLOCKS_PER_SEC) << "\n";
}
//---------------------------------------------------------
//---------------------------------------------------------
int main()
{
  bl::filter_base::ptr f=bl::severity() > bl::severity::info();
  bl::filter_split_action::ptr fcl(new bl::filter_split_action(f));
  bl::sink::ptr sink(new bl::sinks::ostream_sink(std::cout));
  bl::sink::ptr sink2(new bl::sinks::ostream_sink(std::cout));
  bl::sink::ptr sink3(new bl::sinks::ostream_sink(std::cout));
  fcl->on_success(sink);

  bl::logger<bl::default_conditions> s(fcl);


  test_lazy_on(s);
//  test_lazy_off(s);
//  test_empty(s);
//  std::cerr << " with more sinks...\n";
//  fcl->on_success(sink2);
//  fcl->on_success(sink3);
//  test_lazy_on(s);
//  test_lazy_off(s);
//  test_empty(s);


  return 0;
}
