#include <iostream>
#include <boost/logging/logger.hpp>
#include <boost/logging/conditions.hpp>
#include <boost/logging/sinks/ostream_sink.hpp>
namespace bl=boost::logging;

//---------------------------------------------------------
//---------------------------------------------------------
int main()
{
  bl::filter_base::ptr f=bl::severity() > bl::severity::info() && bl::var("my_var") == "test";
  bl::filter_split_action::ptr fcl(new bl::filter_split_action(f));
  bl::sink::ptr sink(new bl::sinks::ostream_sink(std::cout));
  fcl->on_success(sink);

  bl::logger<> s(fcl);
  boost::shared_ptr<bl::variable_set> v(new bl::single_threaded_variable_set);

  v->set("my_var","test");
  s.local().set_parent(v);

  s << "Default<Test> " << " default<fail>" << bl::eol()
    << bl::severity::debug() << "debug(succeed) debug(f=" <<12.1234678 << ")" << bl::eol()
    << bl::severity::warning() << "warn(1234) " << "warn(asfd) warn(f=" <<21.1234678 << ")" << bl::eol()
    << bl::severity::error() << "error(i=" << 45 << ") error (text here)" << bl::eol()
    << bl::build_type::release()
    << bl::severity::warning() << "rwarn(1234) " << "rwarn(asfd) rwarn(f=" <<21.1234678 << ")" << bl::eol()
    << bl::severity::error() << "rerror(i=" << 45 << ") rerror (text here)" << bl::eol();
  s.end_record();

  return 0;
}
